/* run as 
   ./accum n

   where n is the number of processes that will generate integers */

#include <stdio.h>
#include "pvm3.h"

#define NUMINTSTR "2"
#define NUMINTS 2

int main(int argc,char **argv){
  int cc, *tid, nsums,i,sum;
  int *buf;
  char *childargs[2];

  /* nsums number os processes to be spawn */
  sscanf(argv[1],"%d",&nsums);
        
  /* NUMINTS number of integers per process. Notice NUMINTSTR is a string 
with NUMINTS */
  childargs[0]=NUMINTSTR;
  childargs[1]=0;

  buf = (int *) malloc(NUMINTS*sizeof(int));
  /* task a id for each spawn child */
  tid = (int *) malloc(nsums*sizeof(int));


  printf("i'm t%x\n", pvm_mytid());

  /* create child processes: nsums  copies of "getints" */
  cc = pvm_spawn("getints", childargs, 0, "", nsums, tid);

  if (cc != nsums) {
    printf("can't start getints\n");
    pvm_exit();
    exit(1);
  }

  sum = 0;
  /* for each child do */
  for (i=0;i<nsums;i++){
    int senderid,j;
    /* receive any message from any buffer */
    cc = pvm_recv(-1, -1);
    /* information about received buffer */
    pvm_bufinfo(cc, (int*)0, (int*)0, &senderid);
    /* move received buffer to buf */
    pvm_upkint(buf,NUMINTS,1);
    printf("receivedfrom t%x\n", senderid);
    /* accumulate */
    for (j=0;j<NUMINTS;j++)
      sum+=buf[j];
  }
  /* print */
  printf("sum %d\n",sum);
  pvm_exit();
  return 0;
}


