#include<unistd.h>
#include<errno.h>
#include<stdio.h>
#include<stdlib.h>
/* #define _REENTRANT */    /* basic 3-lines for threads */
#include <pthread.h>
/* #include <thread.h>  */
#include<time.h>


void err_abort(const int i){
 printf("%d:%s\n",i,strerror(errno));
 exit(-1);
}

int total, loopmax;

int val = 0;

typedef 
 struct condition{
   pthread_cond_t c;
   int count;
 } condition_t;

void condition_init(condition_t * c){
   pthread_cond_init(&c->c,0);
   c->count = 0;
}

void condition_signal(condition_t * c){
  if (c->count != 0) pthread_cond_signal(&c->c);
}

void condition_wait(condition_t *c, pthread_mutex_t *m){
  c->count++;
  pthread_cond_wait(&c->c,m);
  c->count--;
}

int condition_waiting(condition_t *c){
 return c->count != 0;
}

typedef 
 struct rw_monitor{
   pthread_mutex_t m;
   condition_t okr, okw;
   int writing,readers;
 } rw_monitor_t;


void startread(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  if ((m->writing) || (condition_waiting(&m->okw))) 
    condition_wait(&m->okr,&m->m);
  m->readers++;
  condition_signal(&m->okr);
  pthread_mutex_unlock(&(m->m));
}

void endread(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  m->readers--;
  if ((!m->readers) && (condition_waiting(&m->okw))) 
    condition_signal(&(m->okw));
  pthread_mutex_unlock(&(m->m));
}

void startwrite(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  if ((m->writing) || (m->readers))
    condition_wait(&m->okw,&m->m);
  m->writing = 1;
  pthread_mutex_unlock(&(m->m));
}
  

void endwrite(rw_monitor_t *m){
  pthread_mutex_lock(&(m->m));
  m->writing=0;
  if (condition_waiting(&m->okr)) 
    condition_signal(&(m->okr));
  else condition_signal(&(m->okw));
  pthread_mutex_unlock(&(m->m));
}
 
long timeconv(const struct timespec t){
  return t.tv_nsec;
}

rw_init(rw_monitor_t *mrw){

 mrw->writing=mrw->readers=0;
 condition_init(&mrw->okw);
 condition_init(&mrw->okr);
 pthread_mutex_init(&mrw->m,0);
}

rw_monitor_t mrw;

void *rthread(void *arg){
 int *i=(int *) malloc(sizeof(int));
 int j;
 pthread_t tid = pthread_self();
 int aux;

/*  pthread_detach(tid); */
 for (j=0;j<loopmax;j++){
/*   startread(&mrw); */
   aux = val;
/*   endread(&mrw); */
  printf("%d read %d\n",tid,aux);
 }
/*  startread(&mrw); */
 *i=val;
/*  endread(&mrw); */
 return i;
}
void *wthread(void *arg){
 int *i=(int *) malloc(sizeof(int));
 int j;
 pthread_t tid = pthread_self();
 int aux;

/*  pthread_detach(tid); */
 for (j=0;j<loopmax;j++){
/*   startwrite(&mrw); */
   aux = val;
   aux++;
   val=aux;
/*   endwrite(&mrw); */
  printf("%d read %d\n",tid,aux);
  sleep(2);
 }
/*  startwrite(&mrw); */
 aux=val;
 aux++;
 val=aux;
/*  endread(&mrw); */
 *i=aux;
 return i;
}

int main(int argc, char **argv){
 int i=0,j;
 pthread_t *pt;
 int *lstrd,
     *lstwrt;

 struct timespec t0,t1;
 int status; 

 rw_init(&mrw);

 sscanf(argv[1],"%d",&total);
 sscanf(argv[2],"%d",&loopmax);
 pt= (pthread_t *) malloc((total+1)*sizeof(pthread_t));

 


/*  clock_gettime(CLOCK_REALTIME,&t0); */
 
 
 for(i=0;i<total;i++){ 
   status = pthread_create(pt+i,NULL,&rthread,NULL);
   if (status != 0) err_abort(status);
   printf("created %d:%d\n",i,pt[i]);
 }
/*  status = pthread_create(pt+total,NULL,&wthread,NULL); */
/*  pthread_join(pt[total],&lstwrt); */
 for (i=0;i<total;i++)
  pthread_join(pt[i],&lstrd);

/*  printf("W:%d:R:%d\n",*lstwrt,*lstrd); */

 
/*  clock_gettime(CLOCK_REALTIME,&t1); */


/*  printf("Total time:%ld:%ld:%ld:%ld:%ld\n",t0.tv_sec,t0.tv_nsec,t1.tv_sec,t1.tv_nsec,t1.tv_nsec-t0.tv_nsec); */

 exit(0);

}


