/*
 * Laboratory for Scientific Computing
 * http://www.lam-mpi.org/tutorials/
 * University of Notre Dame
 *
 * MPI Tutorial
 * Homework : Manager/worker (calculate an average in parallel)
 *
 * Mail questions regarding tutorial material to mpi@lam-mpi.org
 */

#include "mpi.h"
#include "stdio.h"
#include <malloc.h>

int
main(int argc, char *argv[])
{
  int rank, size;
  int i, len = 100, tag = 200;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);

  if (rank == 0) { /* Manager Code */

    /* Allocate and initialize the data */ 

    int total, workers = size-1;
    double avg;
    int *data = malloc(sizeof(int)*workers*len);
    int *sum = malloc(sizeof(int)*workers);
    MPI_Request *request = malloc(sizeof(MPI_Request)*workers);
    MPI_Status *status = malloc(sizeof(MPI_Status)*workers);

    for (i = 0; i < workers*len; i++)
      data[i] = i;
    
    /* Send the data to each of the other processes */

    for (i=0; i< workers; i++) {
      int dest = i+1;

      /* Send the data to worker dest, use a non-blocking send
	 and use request[i] */
    }

    /* Wait for all of the sends to complete */
    
    /* Receive the results */

    for (i=0; i < workers; i++) {
      int source = i+1;

      /* Do a non-blocking receive from source, placing the
	 incoming number in the sum array, again use request[i] */

    }
    /* Wait for all of the receives to complete */

    total = 0;
    for (i=0; i < workers; i++) {
      printf("sum[%d] = %d\n", i, sum[i]);
      total += sum[i];
    }

    avg = total / (len * workers);
    printf("The average is %d/%d = %lf\n", total, len*workers, avg);

  } else { /* Worker Code */
    int data[100], sum = 0;
    MPI_Status status;

    /* Receive the data from the manager */
    
    /* calculate my partial sum */

    for (i=0; i < len; i++)
      sum += data[i];
    
    printf("Rank %d, my sum is %d\n", rank, sum);

    /* Send my sum back to the manager */
  }

  MPI_Finalize();
  return 0;
}
