/*
 * Laboratory for Scientific Computing
 * http://www.lam-mpi.org/tutorials/
 * University of Notre Dame
 *
 * MPI Tutorial
 * Homework: Manager/worker (calculate an average in parallel)
 *
 * Mail questions regarding tutorial material to mpi@lam-mpi.org
 */

#include "mpi++.h"
#include <iostream.h>

int
main(int argc, char *argv[])
{
  int rank, size;
  int i, len = 100, tag = 200;

  MPI::Init(argc, argv);

  rank = MPI::COMM_WORLD.Get_rank();
  size = MPI::COMM_WORLD.Get_size();

  if (rank == 0) {

    /* Allocate and initialize the data */ 

    int total, workers = size - 1;
    double avg;
    int* data = new int[workers * len];
    int* sum = new int[workers];

    MPI::Request *request = new MPI::Request[workers];
    MPI::Status *status = new MPI::Status[workers];

    for (i = 0; i < workers * len; i++)
      data[i] = i;
    
    /* Send the data to each of the other processes */

    for (i = 0; i< workers; i++) {
      int dest = i + 1;

      /* Send the data to worker dest, use a non-blocking send
	 and use request[i] */
    }
    MPI::Request::Waitall(workers, request, status);
    
    /* Receive the results */
    for (i = 0; i < workers; i++) {
      int source = i + 1;

      /* Do a non-blocking receive from source, placing the
	 incoming number in the sum array, again use request[i] */
    }
    /* Wait for all of the sends to complete */

    total = 0;
    for (i = 0; i < workers; i++)
      total += sum[i];

    avg = total / (len * workers);
    cout << "The average is " << avg << endl;

  } else {
    int data[100], mysum = 0;
    MPI::Status status;

    /* Receive the data from the manager */

    /* calculate my partial sum */
    for (i = 0; i < len; i++)
      mysum += data[i];
    
    /* Send my sum back to the manager */
  }

  MPI::Finalize();
  return 0;
}
