\documentclass[12pt]{article}
\usepackage{program}
\usepackage{fancyvrb}
\def\stdin{\emph{stdin}}
\def\stdout{\emph{stdout}}
\def\adtdef{\ensuremath{\stackrel{\triangle}{=}}}
\DefineVerbatimEnvironment
  {code}{Verbatim}
  {numbers=left,frame=single}

\title{Projeto e An\'{a}lise de Algoritmos: TP 0\\
Entrega: 23/6, 18h}
\author{Raul H.C. Lopes}

\begin{document}
\maketitle
Escreva um programa para gerar todas as permuta\c c\~{o}es de uma lista
de inteiros.

\begin{itemize}
\item\textbf{Input:} seu programa ler\'{a} um inteiro $n\ge 0$ de
{\stdin} e gerar\'{a} em {\stdout} todas permuta\c c\~{o}es da lista
$[1..n]$.
\item\textbf{output:} o programa gerar\'a uma linha de output para cada permuta\c c\~{a}o gerada. Em cada linha, os n\'{u}meros que compuserem a respectiva permuta\c c\~{a}o ser\~{a}o separados por um esp\c co em branco.
\item\textbf{exemplo em Haskell:} O programa a seguir, escrito em Haskell, usa
um \emph{stack impl\'{\i}cito} (do processador) para produzir uma lista
de todas as permutado\c c\~{o}es da lista $[1..n]$, onde $n$ \'{e} 
fornecido como argumento da linha de comando.


\begin{code}
module Main(main) where

import System(getArgs)

main = do args <- getArgs
          let 
            n = read (args!!0)  --  number
          putStrLn ("perms " ++ (show n) ++ " = " ++ 
                     (show (delperms [1..n])))

delperms []=[[]]
delperms [x]=[[x]]
delperms (x:xs)= concat [(map ((head y1):) 
                              (delperms (y0++(tail y1)))) |
                                 (y0,y1)<-delete (x:xs)] 
                                
delete zs = [(take n zs,drop n zs)| n<-[0..(length zs)-1]]
\end{code}

Para executar o programa acima, fa\c ca:
\begin{enumerate}
\item salva este documento com nome \emph{perms.lhs}
\item compile usando \emph{ghc -op perms.lhs}
\item execute usando \emph{./p 5}
\end{enumerate}

Isso deveria produzir todas as permuta\c c\~oes da lista $[1,2,3,4,5]$.
Note que o programa acima usa o stack de programa para realizar uma 
pesquisa em profundidade na \'{a}rvore de pesquisa das permuta\c c\~{o}es.

\item\textbf{algoritmo}: construa um algoritmo iterativo (com stack expl\'{\i}cito) para resolver o
mesmo problema. Produza duas vers\~{o}es do seu programa: uma que use 
stack expl\'{\i}cito para realizar pesquisa em profundidade e outro 
que use uma \emph{queue} para realizar busca em largura.
item\textbf{estruturas de dados:} crie um tipo \textbf{ilist} com
as seguintes restri\c c\~{o}es:
\begin{program}
{\bf adt} ilist \adtdef 
\ \ \tab inewlist::ilist
icons:: int->ilist->ilist
icar:: ilist->int
icdr:: ilist->ilist
inull:: ilist->int

icar(icons(x,l)) = x
\neg inull(icons(x,l))
inull(inewlist)
icdr(icons(x,l)) = l
\untab
{\bf end}\ ilist
\end{program}

Use o tipo \textbf{ilist} para representar suas listas de n\'{u}meros.

\item\textbf{grupos:} o trabalho ser\'{a} desenvolvido individualmente ou
em grupos de at\'{e} duas pessoas.

\item\textbf{documenta\c c\~{a}o:} apresente um documento em {\TeX},
estilo \emph{literate programming}, descrevendo: algoritmos, detalhes de
implementa\c c\~{a}o e casos de teste.

\item\textbf{linguagem de programa\c c\~{a}o:}  \textbf{C}  ou \textbf{Haskell}
para
implementa\c c\~{a}o, ou \textbf{UNITY} para algoritmo, 
devendo, neste caso, ser apresentada prova de corre\c c\~{a}o.

\item\textbf{Entrega:} 23/6, 18h.

\item\textbf{Identifica\c c\~{a}o:} envie e-mail com subject

\centerline{\bf msc.paa:0}
\item\textbf{formato para submiss\~{a}o:} submeta por e-mail, conforme
as regras da p\'{a}gina do \emph{Senhor do Castelo}, arquivo contendo: 
documento {\TeX}, \emph{makefile}, \emph{expect script}, definindo teste
padr\~{a}o.
 
Consulte as regras de desenvolvimento e submiss\~{a}o 
de trabalhos. 

\end{itemize}
\end{document}
