#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>

void prefsum(int *v,int rank, int size){
  int j;
  MPI_Status st;
  MPI_Win win;
  int l;

  MPI_Win_create(&l,1,sizeof(int),MPI_INFO_NULL,MPI_COMM_WORLD, &win);
  printf("rank:%d:v:%d\n",rank,*v);

  for (j=1;j<size;j*=2){
    
/*
    if (rank<size-j)
      MPI_Send(v,1,MPI_INT,rank+j,1,MPI_COMM_WORLD);
*/
    if (rank+j<size)
      MPI_Accumulate(v,1,MPI_INT,rank+k,1,1,MPI_INT,MPI_SUM,&win);
    MPI_Win_fence(0,&win);
    printf("%d:%d:%d\n",rank,j,*v);

/*
    if (rank-j>=0){
      MPI_Recv(&l,1,MPI_INT,rank-j,1,MPI_COMM_WORLD,&st);
      *v+=l;
      */
    v=l;
    }
  }
  MPI_Win_free(&win);
} 

int
main(int argc, char *argv[])
{
  int rank,size;
  int v,oldv,j,*vec;
  MPI_Status st;

  MPI_Init(&argc, &argv);
  oldv=v = rand();
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  vec=(int *) malloc(size*sizeof(int));
  if (rank==0)
	for (j=0;j<size;j++)  vec[j]=rand()%size;
  MPI_Scatter(vec,1,MPI_INT,&v,1,MPI_INT,0,MPI_COMM_WORLD);

	
  oldv=v;
  printf("start:%d:%d\n",rank,v);
  prefsum(&v,rank,size);

  printf("rank %d:oldv %d:max %d\n",rank,oldv,v);


  MPI_Finalize();
}


 

